import vtk

#-----------------------------------
# Build rendering facilities
#-----------------------------------

# Make a window
renwin = vtk.vtkRenderWindow()
renwin.SetSize(500,500)

# Make a renderer for that window
renderer = vtk.vtkRenderer()
renwin.AddRenderer(renderer)

# Control how it all looks
renderer.SetBackground2(1,1,1)
renderer.SetGradientBackground(1)

# Show it
renwin.Render()

# Access the data processing pipeline that has your data
mapper = vtk.vtkDataSetMapper()
mapper.ScalarVisibilityOff()

# Link that the the display system
actor = vtk.vtkActor()
actor.SetMapper(mapper)
renderer.AddViewProp(actor)

#-----------------------------------
# Build rectilinear grid
#-----------------------------------

fa = vtk.vtkFloatArray()
fa.InsertValue( 0, 0 )
fa.InsertValue( 1, 1 )
fa.InsertValue( 2, 3 )
fa.InsertValue( 3, 6 )

rg = vtk.vtkRectilinearGrid()
rg.SetDimensions(4,4,4)
rg.SetXCoordinates(fa)
rg.SetYCoordinates(fa)
rg.SetZCoordinates(fa)
fa = vtk.vtkFloatArray()

for i in range(0,64):
   fa.InsertValue( i, i )

rg.GetPointData().SetScalars( fa )

#-----------------------------------
# Show point values as glyphs
#-----------------------------------

ss = vtk.vtkSphereSource()
ss.SetRadius(0.2)

gf = vtk.vtkGlyph3D()
gf.SetScaleModeToDataScalingOff()
gf.SetInput(rg)
gf.SetSource(ss.GetOutput())

mapper.SetInputConnection(gf.GetOutputPort())
mapper.ScalarVisibilityOn()
mapper.SetScalarRange(fa.GetRange())
renderer.ResetCamera()
renwin.Render()

#-----------------------------------
# Show point values on structured points output surface
#-----------------------------------

#dssf = vtk.vtkDataSetSurfaceFilter()
#dssf.SetInput(rg)
#mapper.SetInputConnection(dssf.GetOutputPort())
#renwin.Render()

#-----------------------------------
# Show point values on structured points output surface
#-----------------------------------
#iren = vtk.vtkRenderWindowInteractor()
#renwin.SetInteractor(iren)
#iren.Initialize()
#iren.Start()