import vtk
import numpy
import time
import os

#-----------------------------------
# Make a window 
#-----------------------------------

# Make a window 
renwin = vtk.vtkRenderWindow() 
renwin.SetSize(500,500) 

# Make a renderer for that window
renderer = vtk.vtkRenderer() 
renwin.AddRenderer(renderer) 

# Control how it all looks 
renderer.SetBackground2(1,1,1) 
renderer.SetGradientBackground(1) 

# Show it 
renwin.Render() 

#-----------------------------------
# Show some data 
#-----------------------------------

# Access the data processing pipeline that has your data 
mapper = vtk.vtkDataSetMapper() 
mapper.ScalarVisibilityOn()

# Link that the the display system 
actor = vtk.vtkActor() 
actor.SetMapper(mapper) 
renderer.AddViewProp(actor) 
renwin.Render() 

# Adjust the camera for a better view 
renderer.ResetCamera() 
renwin.Render()

actorProperty = actor.GetProperty()
actorProperty.SetDiffuseColor(0,1,1)
renwin.Render()

# Your data path here
data = numpy.loadtxt("c:/VTKSchoolData/data_morphed.txt")
newdata = data.reshape(29*31*30)

xdim = 29
ydim = 31
timeSteps = 30
  
arraySize  = xdim * ydim  
imageData = vtk.vtkImageData()
imageData.SetOrigin(0,0,0)
imageData.SetDimensions(xdim,ydim,1)

mapper.SetInput(imageData)
mapper.ScalarVisibilityOn()
   
floatArrayList = []

for t in range(0, timeSteps):
    
    floatArrayList.append(vtk.vtkFloatArray())    
    floatArrayList[t].SetNumberOfTuples(29*31)
    tupleId = 0
    for i in range(t*arraySize,(t+1)*arraySize):
        value = newdata[i]
        floatArrayList[t].SetValue(tupleId,value)
        tupleId=tupleId+1
        
    imageData.GetPointData().SetScalars(floatArrayList[t])
    mapper.SetInput(imageData)
    print imageData.GetScalarRange()
    renderer.ResetCamera()
    renwin.Render()

    triangles = vtk.vtkDataSetTriangleFilter() 

    #Connect it 
    triangles.SetInput(imageData)
    
    dataSetWriter = vtk.vtkDataSetWriter()
    dataSetWriter.SetInputConnection(triangles.GetOutputPort())
    outputFileName = os.getcwd() + "/data_morphed_" + str(t) + ".vtk"
    print outputFileName    
    dataSetWriter.SetFileName(outputFileName)
    dataSetWriter.Write()
    time.sleep(1)

#-----------------------------------
# Exercise: warp a time istance of the data and clip it
# with a 3D widget
#-----------------------------------
