import sys, getopt
import vtk

def main(argv):
   inputfile = ''
   outputfile = ''
   try:
      opts, args = getopt.getopt(argv,"hi:o:",["ifile=","ofile="])
   except getopt.GetoptError:
      print 'importSTLExportVTP.py -i <inputfile> -o <outputfile>'
      sys.exit(2)
   for opt, arg in opts:
      if opt == '-h':
         print 'importSTLExportVTP.py -i <inputfile> -o <outputfile>'
         sys.exit()
      elif opt in ("-i", "--ifile"):
         inputfile = arg
      elif opt in ("-o", "--ofile"):
         outputfile = arg
   print 'Input file is ', inputfile
   print 'Output file is ', outputfile

   stlReader = vtk.vtkSTLReader()
   stlReader.SetFileName(inputfile)
   stlReader.Update()
   polyDataWriter = vtk.vtkXMLPolyDataWriter()
   polyDataWriter.SetInputConnection(stlReader.GetOutputPort())
   polyDataWriter.SetFileName(outputfile)
   polyDataWriter.Write()

if __name__ == "__main__":
   main(sys.argv[1:])